#include<pthread.h>
#include<signal.h>
#include<memory.h>
#include<setjmp.h>

#define THREAD_CALL void*
#define THREAD_ID pthread_t
#define CreateThread(p,id) pthread_create(id,0,p,0)

#define _try { sigjmp_buf buf; pthread_setspecific(jmp_key,&buf); if(!sigsetjmp(buf,1)) 
#define _catch else
#define _final pthread_setspecific(jmp_key,0); }


pthread_key_t jmp_key;


void hand(int sig)
{
  sigjmp_buf *ref=(sigjmp_buf*)pthread_getspecific(jmp_key);
	if(ref) siglongjmp(*ref,1);
} 


inline void TryInit() 
{
	struct sigaction act;
	memset(&act,0,sizeof(act));
	act.sa_handler=hand;
	sigaction(SIGFPE,&act,0); 
	sigaction(SIGSEGV,&act,0); 
	pthread_key_create(&jmp_key,0);	// ñîçäà¸ì êëþ÷ äëÿ ëîêàëüíûõ äàííûõ ïîòîêà
}
